unit u_firemonkey_objects_display;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Layouts, FMX.Memo,
  FMX.Objects;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    exit_: TButton;
    clear_: TButton;
    Splitter1: TSplitter;
    Button1: TButton;
    stream_button_: TButton;
    rtti_button_: TButton;
    create_button_: TButton;
    Panel3: TPanel;
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure stream_button_Click(Sender: TObject);
    procedure rtti_button_Click(Sender: TObject);
    procedure create_button_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

implementation
    uses u_display_xe2, u_types_constants_xe2
        , u_display_fmx_object
        , u_fmx_object
        ;


    {$R *.fmx}

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        Memo1.Lines.Clear;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.Button1Click(Sender: TObject);
      begin
        display_fmx_object(Button1);
      end;

    procedure TForm1.stream_button_Click(Sender: TObject);
      begin
        display(f_object_stream_string(stream_button_));
      end; // stream_button_Click

    procedure TForm1.rtti_button_Click(Sender: TObject);
      begin
        display(f_display_component_property_list(rtti_button_));
      end; // rtti_button_Click

    procedure TForm1.create_button_Click(Sender: TObject);
      begin
        with f_c_name_to_fmx_component('tButton', Self)  as tButton do
        begin
          Parent:= Panel3;
          Position.X:= 5;
          Position.Y:= 5;
          Text:= 'button_ok';
        end;
      end; // create_button_Click



end.
