unit u_display_fmx_object;
  interface
    uses TypInfo, System.SysUtils, System.Classes
        , FMX.Types;

    function f_display_fmx_object_children_max(p_c_base_fmx_object: tFmxObject;
        p_level_max: Integer): String;
    function f_display_fmx_object_children(p_c_base_fmx_object: tFmxObject): String;
    procedure display_fmx_object(p_c_base_fmx_object: TFmxObject);

    function f_display_fmx_object_style_name(p_c_fmx_object: tFmxObject): String;

    function f_indexof_fmx_child_object(p_c_parent_fmx_object, p_c_fmx_object: tFmxObject): Integer;
    function f_display_component_property_list(p_c_component: tComponent): String;

  implementation
    uses u_types_constants_xe2, u_display_xe2;

    function f_display_fmx_object_children_max(p_c_base_fmx_object: tFmxObject;
        p_level_max: Integer): String;

      procedure _display_fmx_object_recursive(p_level: Integer; p_c_fmx_object: TFmxObject);
        var l_child_index: Integer;
            l_display: String;
        begin
          with p_c_fmx_object do
          begin
            if Name= ''
              then l_display:= ''
              else l_display:= '['+ Name+ '] ';

            if StyleName<> ''
              then l_display:= StyleName+ ': ';

            if Result<> ''
              then Result:= Result+ k_new_line;
            Result:= Result+ f_spaces(p_level* 2)+ l_display+ ClassName;

            if (p_level< p_level_max) and (p_level_max>= 0)
              then
                for l_child_index := 0 to ChildrenCount- 1 do
                  _display_fmx_object_recursive(p_level+ 1, Children[l_child_index]);
          end;
        end; // _display_fmx_object_recursive

      begin // f_display_fmx_object_children_max
        Result:= '';
        _display_fmx_object_recursive(0, p_c_base_fmx_object);
      end; // f_display_fmx_object_children_max

    function f_display_fmx_object_children(p_c_base_fmx_object: tFmxObject): String;
      begin
        Result:= f_display_fmx_object_children_max(p_c_base_fmx_object, -1);
      end; // f_display_fmx_object_children

    function f_indexof_fmx_child_object(p_c_parent_fmx_object, p_c_fmx_object: tFmxObject): Integer;
      var l_child_index: Integer;
      begin
        Result:= -1;
        with p_c_parent_fmx_object do
          for l_child_index:= 0 to ChildrenCount- 1 do
            if Children[l_child_index]= p_c_fmx_object
              then begin
                  Result:= l_child_index;
                  Exit;
                end;
      end; // f_indexof_fmx_child_object

    function f_display_fmx_object_style_name(p_c_fmx_object: tFmxObject): String;
      begin
        with p_c_fmx_object do
          if StyleName= ''
            then Result:= ClassName
            else Result:= StyleName+ ': '+ ClassName;
      end; // f_display_fmx_object_style_name

(*
    function f_display_fmx_object_children(p_c_base_fmx_object: tFmxObject): String;

      procedure _display_fmx_object_recursive(p_level: Integer; p_c_fmx_object: TFmxObject);
        var l_child_index: Integer;
            l_display: String;
        begin
          with p_c_fmx_object do
          begin
            if StyleName= ''
              then l_display:= ''
              else l_display:= StyleName+ ': ';

            if Result<> ''
              then Result:= Result+ k_new_line;
            Result:= Result+ f_spaces(p_level* 2)+ l_display+ ClassName;

            for l_child_index := 0 to ChildrenCount- 1 do
              _display_fmx_object_recursive(p_level+ 1, Children[l_child_index]);
          end;
        end; // _display_fmx_object_recursive

      begin // f_display_fmx_object_children
        Result:= '';
        _display_fmx_object_recursive(0, p_c_base_fmx_object);
      end; // f_display_fmx_object_children

    function f_display_fmx_object_children_max(p_c_base_fmx_object: tFmxObject;
        p_level_max: Integer): String;

      procedure _display_fmx_object_recursive(p_level: Integer; p_c_fmx_object: TFmxObject);
        var l_child_index: Integer;
            l_display: String;
        begin
          with p_c_fmx_object do
          begin
            if StyleName= ''
              then l_display:= ''
              else l_display:= StyleName+ ': ';

            if Result<> ''
              then Result:= Result+ k_new_line;
            Result:= Result+ f_spaces(p_level* 2)+ l_display+ ClassName;

            if p_level< p_level_max
              then
                for l_child_index := 0 to ChildrenCount- 1 do
                  _display_fmx_object_recursive(p_level+ 1, Children[l_child_index]);
          end;
        end; // _display_fmx_object_recursive

      begin // f_display_fmx_object_children_max
        Result:= '';
        _display_fmx_object_recursive(0, p_c_base_fmx_object);
      end; // f_display_fmx_object_children_max
*)
    function f_display_component_property_list(p_c_component: tComponent): String;
      var l_pt_property_list: PPropList;
          l_property_count : Integer;
          l_property_index : Integer;
          l_property_name, l_property_value: String;
      begin
        Result:= '';
        GetMem(l_pt_property_list,SizeOf(Pointer) * GetTypeData(p_c_component.ClassInfo)^.PropCount);

        try
          l_property_count := GetPropList(p_c_component.ClassInfo,tkProperties, l_pt_property_list,true);
          for l_property_index := 0 to l_property_count- 1 do
          begin
            l_property_name:= l_pt_property_list^[l_property_index].Name;
            l_property_value:= GetPropValue(p_c_component, l_property_name, True);

            if Result<> ''
              then Result:= Result+ k_new_line;
            Result:= Result+ l_property_name+ ': '+ l_property_value;
          end;
        finally
          FreeMem(l_pt_property_list);
        end;
      end; // f_display_component_property_list

    procedure display_fmx_object(p_c_base_fmx_object: TFmxObject);

      procedure _display_fmx_object_recursive(p_level: Integer; p_c_fmx_object: TFmxObject);
        var l_child_index: Integer;
            l_display: String;
        begin
          with p_c_fmx_object do
          begin
            if StyleName= ''
              then l_display:= ''
              else l_display:= StyleName+ ': ';

            display(f_spaces(p_level* 2)+ l_display+ ClassName);

            for l_child_index := 0 to ChildrenCount- 1 do
              _display_fmx_object_recursive(p_level+ 1, Children[l_child_index]);
          end;
        end; // _display_fmx_object_recursive

      begin // display_fmx_object
        _display_fmx_object_recursive(0, p_c_base_fmx_object);
      end; // display_fmx_object


end.
